> For the complete documentation index, see [llms.txt](https://docs.essencefinance.io/llms.txt). Markdown versions of documentation pages are available by appending `.md` to page URLs; this page is available as [Markdown](https://docs.essencefinance.io/development/smart-contracts/refs/uniref.md).

# UniRef

defines some utilities around interacting with Uniswap

the uniswap pair should be CHI and another asset

## Functions

### constructor

```solidity
function constructor(
    address _core,
    address _pair,
    address _oracle,
    address _backupOracle
) internal
```

UniRef constructor

#### Parameters

| Name            | Type    | Description                |
| --------------- | ------- | -------------------------- |
| `_core`         | address | Chi Core to reference      |
| `_pair`         | address | Uniswap pair to reference  |
| `_oracle`       | address | oracle to reference        |
| `_backupOracle` | address | backup oracle to reference |

### setPair

```solidity
function setPair(
    address newPair
) external
```

set the new pair contract

#### Parameters

| Name      | Type    | Description  |
| --------- | ------- | ------------ |
| `newPair` | address | the new pair |

### getReserves

```solidity
function getReserves() public returns (uint256 chiReserves, uint256 tokenReserves)
```

pair reserves with chi listed first

### \_setupPair

```solidity
function _setupPair(
    address newPair
) internal
```

#### Parameters

| Name      | Type    | Description |
| --------- | ------- | ----------- |
| `newPair` | address |             |

### \_token

```solidity
function _token() internal returns (address)
```


---

# Agent Instructions
This documentation is published with GitBook. GitBook is the documentation platform designed so that both humans and AI agents can read, navigate, and reason over technical content effectively. Learn more at gitbook.com.

## Querying This Documentation
If you need additional information that is not directly available in this page, you can query the documentation dynamically by asking a question.

Perform an HTTP GET request on the current page URL with the `ask` query parameter, and the optional `goal` query parameter:

```
GET https://docs.essencefinance.io/development/smart-contracts/refs/uniref.md?ask=<question>&goal=<endgoal>
```

`ask` is the immediate question: it should be specific, self-contained, and written in natural language.
`goal` is optional and describes the broader end goal you are ultimately trying to accomplish on behalf of the user. GitBook uses it to tailor the answer towards what is most useful for that goal.

The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
